; ------------------------------------------------------
; 1kPack v0.5 - Framework
; Written by Franck "hitchhikr" Charlet / Neural
; ------------------------------------------------------
; buildblock RELEASE
; CAPT "[SOURCEDIR]nasmw.exe" -f bin "%2" -o "%1.bin" -s -O9
; CAPT "[SOURCEDIR]1kpack.exe" "%1.bin"
; buildblockend

; ------------------------------------------------------
; Header
                                        bits    32

; ------------------------------------------------------
; Includes
                                        %include "Dx9_nasm.inc"

; ------------------------------------------------------
; Constants
;%define GRAB_SCREENSHOT
;%define DEBUG
WS_EX_TOPMOST                           equ     0x8
VK_ESCAPE                               equ     0x1b

SCREENX                                 equ     1024
SCREENY                                 equ     768
SCREENDEPTH                             equ     D3DFMT_A8R8G8B8     ; 32 bits

TYPE_PLANEVERTEX                        equ     D3DFVF_XYZ
PLANEVERTEX_SIZE                        equ     (3 * 4)

BASE                                    equ     0x420000

; Those are located inside the depacker
POS_fnc_exit                            equ     0x410090
POS_fnc_D3DXCompileShader               equ     0x410094
POS_fnc_LoadLibrary                     equ     0x4100b4
POS_fnc_GetProcAddress                  equ     0x4100b8
POS_fnc_QueryPerformanceCounter         equ     0x4100bc

; !!! Only valid for d3dx9_30.dll !!!
D3DX_D3DXCompileShader                  equ     0xda6de
D3DX_D3DXCreateTextureFromFileInMemoryEx equ    (D3DX_D3DXCompileShader - 0xc1341)
D3DX_D3DXCreateTexture                  equ    (D3DX_D3DXCompileShader - 0xbe4a2)

; ------------------------------------------------------
; Structures

; ------------------------------------------------------
; Vars datas
Device                              equ     0
OldTime                             equ     Device + 4
CurrTime			    equ     OldTime + 8
HTimerFreq                          equ     CurrTime + 8 
pConstantTable			    equ     HTimerFreq + 8
delta				    equ     pConstantTable + 4
PixelShader                         equ     delta + 4 
;VertexShader                        equ     PixelShader + 4

                                    .code

; ---------------------------------------------------------
; Program entry point
; base address = 0x420000
; edi contains D3DXCompileShader
EntryPoint:                         ;sub     edi, D3DX_D3DXCreateTextureFromFileInMemoryEx
                                    ;; stack contains D3DXCreateTextureFromFileInMemoryEx
                                    ;push    edi

                                    ; Import the functions we need
                                    mov     edi, table_dlls + BASE
                                    push    3                                           ; Amount of functions in the 1st DLL
                                    pop     ebx
load_dlls:                          push    edi
                                    call    dword [POS_fnc_LoadLibrary]
                                    repne   scasb                                       ; go to end of string
                                    push    ebx
load_functions:                     push    eax
                                    push    edi
                                    push    eax
                                    call    dword [POS_fnc_GetProcAddress]
                                    stosd
                                    pop     eax
                                    repne   scasb                                       ; go to end of string
                                    dec     ebx
                                    jnz     load_functions
                                    pop     ebx
                                    dec     ebx
                                    jnz     load_dlls
                                    ; ----------------------------------------------------

                                    mov     esi, API_CreateWindowEx + BASE
                                    mov     edi, POS_fnc_QueryPerformanceCounter
                                    mov     ebp, Vars + 128 + BASE                      ; MUST BE ALIGNED !!

                                    lea     eax, [ebp + PixelShader]
                                    ;lea     ebx, [ebp + VertexShader]

                                    push    ebp                                         ; CreateDevice
                                    push    Present_Buffer + BASE
                                    push    D3DCREATE_SOFTWARE_VERTEXPROCESSING

                                    push    D3D_SDK_VERSION                             ; Direct3DCreate9

                                    lea	    ebx,[ebp + pConstantTable]			; D3DXCompileShader
                                    push    ebx
                                    push    0
                                    push    eax
                                    push    0
                                    push    PShaderProfileName + BASE
                                    push    ProcedureName + BASE
                                    push    0
                                    push    0
                                    push    (fPShader - PShader)
                                    push    PShader + BASE

;                                    push    0                                           ; D3DXCompileShader
;                                    push    0
;                                    push    ebx
;                                    push    0
;                                    push    VShaderProfileName + BASE
;                                    push    ProcedureName + BASE
;                                    push    0
;                                    push    0
;                                    push    (fVShader - VShader)
;                                    push    VShader + BASE

                                    push    0                                           ; SetCursor

                                    push    0                                           ; CreateWindowEx
                                    push    0
                                    push    0
                                    push    0
                                    push    0
                                    push    0
                                    push    0
                                    push    0
                                    push    0
                                    push    0
                                    push    ClassName + BASE
                                    push    WS_EX_TOPMOST
                                    call    dword [esi]                                 ; + (API_CreateWindowEx - API_CreateWindowEx)]
                                    mov     ebx, eax
                                    call    dword [esi + (API_SetCursor - API_CreateWindowEx)]

                                    ;call    dword [edi + (POS_fnc_D3DXCompileShader - POS_fnc_QueryPerformanceCounter)]
                                    call    dword [edi + (POS_fnc_D3DXCompileShader - POS_fnc_QueryPerformanceCounter)]

                                    ; ------------------------------------------------------
                                    call    dword [esi + (API_Direct3DCreate9 - API_CreateWindowEx)]

                                    push    ebx
                                    push    D3DDEVTYPE_HAL
                                    push    D3DADAPTER_DEFAULT                          ; (0)
                                    push    eax
                                    mov     ebx, [eax]
                                    call    [ebx + IDirect3D9.CreateDevice]

                                    lea     eax, [ebp + PixelShader]
                                    push    eax
                                    mov     eax, [eax]
                                    push    eax
                                    mov     ebx, [eax]
                                    call    [ebx + ID3DXConstantTable.GetBufferPointer]
                                    push    eax
                                    mov     eax, [ebp]
                                    push    eax
                                    mov     ebx, [eax]
                                    call    [ebx + IDirect3DDevice9.CreatePixelShader]

				    mov     eax,[ebp + pConstantTable]
				    push    API_SetCursor + 8 + BASE
				    push    dword 0
				    push    eax
				    mov     ebx,[eax]
				    call    dword [ebx + ID3DXConstantTable.GetConstantByName]
				    mov     [ebp + delta],eax

;                                    lea     eax, [ebp + VertexShader]
;                                    push    eax
;                                    mov     eax, [eax]
;                                    push    eax
;                                    mov     ebx, [eax]
;                                    call    [ebx + ID3DXConstantTable.GetBufferPointer]
;                                    push    eax
;                                    mov     eax, [ebp]
;                                    push    eax
;                                    mov     ebx, [eax]
;                                    call    [ebx + IDirect3DDevice9.CreateVertexShader]

;                                    pop     ebx                ; ebx = D3DXCreateTextureFromFileInMemoryEx

                                    lea     eax, [ebp + OldTime]
                                    push    eax
                                    call    dword [edi + (POS_fnc_QueryPerformanceCounter - POS_fnc_QueryPerformanceCounter)]

; ------------------------------------------------------
; Program loop
MainLoop:
                                    ; ------------------------------------------------------
                                    ; Obtain the frames timer
                                    fild    qword [ebp + OldTime]
                                    lea     eax, [ebp + CurrTime]
                                    push    eax
                                    call    dword [edi + (POS_fnc_QueryPerformanceCounter - POS_fnc_QueryPerformanceCounter)]
                                    fild    qword [ebp + CurrTime]
                                    fsubp   st1, st0
                                    lea     eax, [ebp + HTimerFreq]
                                    push    eax
                                    call    dword [esi + (API_QueryPerformanceFrequency - API_CreateWindowEx)]
                                    fild    qword [ebp + HTimerFreq]
                                    fdivp   st1, st0

                                    ; ------------------------------------------------------
                                    ; Animate
				    push    eax
				    fstp    dword [esp]
				    push    dword [ebp + delta]
				    push    dword [ebp + Device]
				    mov     eax,[ebp + pConstantTable]
				    push    eax
				    mov     ebx,[eax]
				    call    dword [ebx + ID3DXConstantTable.SetFloat]

                                    ; ------------------------------------------------------
                                    ; Display a rectangle
                                    push    VK_ESCAPE                           ; GetAsyncKeyState

                                    push    0                                   ; Present
                                    push    0
                                    push    0
                                    push    0
                                    mov     eax, [ebp]
                                    push    eax
                                    mov     ebx, [eax]

                                    push    eax                                 ; EndScene

                                    push    PLANEVERTEX_SIZE                    ; DrawPrimitiveUP
                                    push    Square + BASE
                                    push    2
                                    push    D3DPT_TRIANGLEFAN
                                    push    eax

                                    push    TYPE_PLANEVERTEX                    ; SetFVF
                                    push    eax

                                    push    dword [ebp + PixelShader]           ; SetPixelShader
                                    push    eax

                                    ;push    dword [ebp + VertexShader]          ; SetVertexShader
                                    ;push    eax

                                    push    eax
                                    call    [ebx + IDirect3DDevice9.BeginScene]
                                    ;call    [ebx + IDirect3DDevice9.SetVertexShader]
                                    call    [ebx + IDirect3DDevice9.SetPixelShader]
                                    call    [ebx + IDirect3DDevice9.SetFVF]
                                    call    [ebx + IDirect3DDevice9.DrawPrimitiveUP]
                                    call    [ebx + IDirect3DDevice9.EndScene]
                                    call    [ebx + IDirect3DDevice9.Present]
                                    call    dword [esi + (API_GetAsyncKeyState - API_CreateWindowEx)]
                                    sahf
                                    jns     MainLoop
                                    call    dword [edi + (POS_fnc_exit - POS_fnc_QueryPerformanceCounter)]

; ------------------------------------------------------
; Datas
ClassName:                          db      "edi"
ProcedureName:                      db      "t", 0
;VShaderProfileName:                 db      "vs_3_0", 0
PShaderProfileName:                 db      "ps_3_0", 0


; I think even a minimal vertex shader is required on NVIDIA cards
; but i'm not totally sure.
;VShader:                            db      "float4 t(float4 x:position):position"
;                                    db      "{"
;                                    db      "return x;"
;                                    db      "}"
;fVShader:
PShader:                            db	    "sampler s;"
				    db      "uniform float r;"
                                    db      "float4 t(float2 x:vpos):color"
                                    db      "{"
				    ;db      "x.x/=1024;"       ; convert to 0.0..1.0
				    ;db      "x.y/=768;"
  				    db      "return 1;"         
                                    db      "}"
fPShader:
                                    ; -------------------------------
table_dlls:
                                    ; 3 functions
                                    db      "user32", 0
API_CreateWindowEx:                 db      "CreateWindowExA", 0
API_SetCursor:                      db      "SetCursor", 0
API_GetAsyncKeyState:               db      "GetAsyncKeyState", 0

                                    ; 2 functions
                                    db      "d3d9", 0
API_Direct3DCreate9:                db      "Direct3DCreate9", 0
                                    dd      0
                                    db      0

                                    ; 1 function
                                    db      "kernel32", 0
API_QueryPerformanceFrequency:      db      "QueryPerformanceFrequency", 0

                                    align   4

Square:                             dd      -1.0, -1.0,  1.0
                                    dd      -1.0,  1.0,  1.0
                                    dd       1.0,  1.0,  1.0
                                    dd       1.0, -1.0,  1.0

Present_Buffer:                     dd      SCREENX                 ;dpBackBufferWidth
                                    dd      SCREENY                 ;dpBackBufferHeight
                                    dd      SCREENDEPTH             ;dpBackBufferFormat
                                    dd      0                       ;dpBackBufferCount
                                    dd      0                       ;dpMultiSampleType
                                    dd      0                       ;dpMultiSampleQuality
                                    dd      D3DSWAPEFFECT_DISCARD   ;dpSwapEffect
                                    
                                    %ifdef DEBUG
                                    dd     0                       ;dphDeviceWindow
                                    dd     1                       ;dpWindowed 

                                    ;we don't need that, the section is zero cleared already
                                    ;dd     0                       ;dpEnableAutoDepthStencil
                                    ;dd     0                       ;dpAutoDepthStencilFormat (D3DFMT_D16)
                                    ;dd     0                       ;dpFlags
                                    ;dd     0                       ;dpFullScreen_RefreshRateInHz
                                    ;dd     0                       ;dpFullScreen_PresentationInterval
                                    %endif
Vars:
; ------------------------------------------------------
